/************************************************/
/*						*/
/*	Program to execute some Regulus function*/
/*	under root ID.				*/
/*						*/
/************************************************/
#include	<stdio.h>
#include	<unistd.h>
#include	<string.h>
#include	<errno.h>
#include	<stdlib.h>
#include	<pwd.h>
#include	<syslog.h>
#include	<sys/stat.h>

#define	APPNAME	"regsudo2"
#define	BASE	"base"

#define VERSION "$Revision: 2.4.0.95 $"

static char *appname;

static char *trustedapp[]={
			  "regadduser",
			  "reghtpass",
			  "regaddweb",
			  "regwebban",
			  "stopregulus",
			  (char *)0
			  };
/*

*/
/************************************************/
/*						*/
/*	Subroutine to display the usage		*/
/*						*/
/************************************************/
static void usage()

{
char version[200];

(void) strcpy(version,VERSION);
*(strrchr(version,' '))='\000';
(void) fprintf(stderr,"%s %s\n",appname,strchr(version,' '));
(void) fprintf(stderr,"usage: %s program_name\n",appname);
(void) fprintf(stderr,"\t\tprogram_name  : Regulus utility to be run under "
		      "root ID\n");
(void) fprintf(stderr,"\t\tEnvironement variable 'base' must contain the "
		      "Regulus base directory");
(void) exit(-1);
}
/*

*/
/************************************************/
/*						*/
/*	Executing shell searching first in	*/
/*	base/conf/shell then in base/shell	*/
/*						*/
/************************************************/
static int letsdoit(char *username,char *rootname,char *base,
		     char *trusted,char *argv[],char *env[])

{
static	char *spath[]={"/conf",""};
int i;

for (i=0;i<2;i++) {
  struct stat bufstat;
  char execpath[300];

  (void) sprintf(execpath,"%s%s/shell/%s.sh",base,spath[i],trusted);
  if (stat(execpath,&bufstat)<0) {
    (void) syslog(LOG_DEBUG,"regsudo.c,letsdoit, '%s' not found",execpath);
    continue;
    }
  (void) syslog(LOG_DEBUG,"User %s executing '%s' as '%s'",
			   username,execpath,rootname);
  if (execve(execpath,argv,env)<0) {
    (void) syslog(LOG_DEBUG,"Unable to execute '%s', error='%s'",
			     execpath,strerror(errno));
    return -1;
    }
  return 0;
  }
(void) syslog(LOG_DEBUG,"Unable to find a '%s' as trusted shell to execute",
			 trusted);
return -1;
}
/*

*/
/************************************************/
/*						*/
/*	Main program				*/
/*						*/
/************************************************/
int main(int argc,char *argv[],char *env[])

{
char *base;

appname=APPNAME;
(void) openlog(appname,LOG_PID,0);
if ((base=getenv(BASE))!=(char *)0) {
  struct passwd *pw;

  if ((pw=getpwuid(getuid()))!=(struct passwd *)0) {
    int i;

    for (i=0;trustedapp[i]!=(char *)0;i++) {
      if (strcmp(trustedapp[i],argv[1])==0) {
	char *rootname;
  	struct passwd *pwroot;

        rootname="Unknown user";
	if ((pwroot=getpwuid(geteuid()))!=(struct passwd *)0)
	  rootname=pwroot->pw_name;
	(void) setreuid(geteuid(),(uid_t)-1);
	(void) exit(letsdoit(pw->pw_name,rootname,base,argv[1],&(argv[1]),env));
        }
      }
    }
  (void) syslog(LOG_DEBUG,"User %s unauthorised to execute '%s' as root",
			   pw->pw_name,argv[1]);
  }
else
  (void) usage();
return 0;
}
